Index: c/src/lib/libbsp/arm/altera-cyclone-v/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/altera-cyclone-v/Makefile.am	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/altera-cyclone-v/Makefile.am	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -191,9 +191,6 @@
 
 # Console
-libbsp_a_SOURCES += ../../shared/console.c
-libbsp_a_SOURCES += ../../shared/console_control.c
-libbsp_a_SOURCES += ../../shared/console_read.c
-libbsp_a_SOURCES += ../../shared/console_select_simple.c
-libbsp_a_SOURCES += ../../shared/console_write.c
+libbsp_a_SOURCES += ../../shared/console-termios-init.c
+libbsp_a_SOURCES += ../../shared/console-termios.c
 libbsp_a_SOURCES += console/console-config.c
 
Index: c/src/lib/libbsp/arm/altera-cyclone-v/console/console-config.c
===================================================================
--- c/src/lib/libbsp/arm/altera-cyclone-v/console/console-config.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/altera-cyclone-v/console/console-config.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2013-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
@@ -13,8 +13,4 @@
  */
 
-#include <assert.h>
-#include <stdint.h>
-#include <stdbool.h>
-#include <libchip/serial.h>
 #include <libchip/ns16550.h>
 
@@ -22,4 +18,5 @@
 #include <bsp/irq.h>
 #include <bsp/alt_clock_manager.h>
+#include <bsp/console-termios.h>
 #include "socal/alt_rstmgr.h"
 #include "socal/socal.h"
@@ -28,10 +25,8 @@
 
 #ifdef BSP_USE_UART_INTERRUPTS
-  #define DEVICE_FNS &ns16550_fns
+  #define DEVICE_FNS &ns16550_handler_interrupt
 #else
-  #define DEVICE_FNS &ns16550_fns_polled
+  #define DEVICE_FNS &ns16550_handler_polled
 #endif
-
-static bool altera_cyclone_v_uart_probe( int minor );
 
 static uint8_t altera_cyclone_v_uart_get_register(uintptr_t addr, uint8_t i)
@@ -49,63 +44,17 @@
 }
 
-console_tbl Console_Configuration_Ports[] = {
-#ifdef CYCLONE_V_CONFIG_CONSOLE
-  {
-    .sDeviceName   = "/dev/ttyS0",
-    .deviceType    = SERIAL_NS16550,
-    .pDeviceFns    = DEVICE_FNS,
-    .deviceProbe   = altera_cyclone_v_uart_probe,
-    .pDeviceFlow   = NULL,
-    .ulMargin      = 16,
-    .ulHysteresis  = 8,
-    .pDeviceParams = (void *)CYCLONE_V_UART_BAUD,
-    .ulCtrlPort1   = (uint32_t)ALT_UART0_ADDR,
-    .ulCtrlPort2   = 0,
-    .ulDataPort    = (uint32_t)ALT_UART0_ADDR,
-    .getRegister   = altera_cyclone_v_uart_get_register,
-    .setRegister   = altera_cyclone_v_uart_set_register,
-    .getData       = NULL,
-    .setData       = NULL,
-    .ulClock       = 0,
-    .ulIntVector   = ALT_INT_INTERRUPT_UART0
-  },
-#endif
-#ifdef CYCLONE_V_CONFIG_UART_1
-  {
-    .sDeviceName   = "/dev/ttyS1",
-    .deviceType    = SERIAL_NS16550,
-    .pDeviceFns    = DEVICE_FNS,
-    .deviceProbe   = altera_cyclone_v_uart_probe,
-    .pDeviceFlow   = NULL,
-    .ulMargin      = 16,
-    .ulHysteresis  = 8,
-    .pDeviceParams = (void *)CYCLONE_V_UART_BAUD,
-    .ulCtrlPort1   = (uint32_t)ALT_UART1_ADDR,
-    .ulCtrlPort2   = 0,
-    .ulDataPort    = (uint32_t)ALT_UART1_ADDR,
-    .getRegister   = altera_cyclone_v_uart_get_register,
-    .setRegister   = altera_cyclone_v_uart_set_register,
-    .getData       = NULL,
-    .setData       = NULL,
-    .ulClock       = 0,
-    .ulIntVector   = ALT_INT_INTERRUPT_UART1
-  }
-#endif
-};
-
-unsigned long Console_Configuration_Count =
-  RTEMS_ARRAY_SIZE(Console_Configuration_Ports);
-
-bool altera_cyclone_v_uart_probe(int minor)
+static bool altera_cyclone_v_uart_probe(
+  rtems_termios_device_context *base,
+  uint32_t uart_set_mask
+)
 {
+  ns16550_context *ctx = (ns16550_context *) base;
   bool            ret           = true;
-  uint32_t        uart_set_mask;
   uint32_t        ucr;
   ALT_STATUS_CODE sc;
-  void*           location;
+  void*           location = (void *) ctx->port;
 
   /* The ALT_CLK_L4_SP is required for all SoCFPGA UARTs. 
    * Check that it's enabled. */
-  assert( alt_clk_is_enabled(ALT_CLK_L4_SP) == ALT_E_TRUE );
   if ( alt_clk_is_enabled(ALT_CLK_L4_SP) != ALT_E_TRUE ) {
     ret = false;
@@ -113,26 +62,5 @@
 
   if ( ret ) {
-    switch(minor)
-    {
-      case(0):
-        /* UART 0 */
-        uart_set_mask = ALT_RSTMGR_PERMODRST_UART0_SET_MSK;
-        location      = ALT_UART0_ADDR;
-      break;
-      case(1):
-        /* UART 1 */
-        uart_set_mask = ALT_RSTMGR_PERMODRST_UART1_SET_MSK;
-        location      = ALT_UART1_ADDR;
-      break;
-      default:
-        /* Unknown case */
-        assert( minor == 0 || minor == 1 );
-        ret = false;
-      break;
-    }
-  }
-  if ( ret ) {
-    sc = alt_clk_freq_get(ALT_CLK_L4_SP, &Console_Configuration_Ports[minor].ulClock);
-    assert( sc == ALT_E_SUCCESS );
+    sc = alt_clk_freq_get(ALT_CLK_L4_SP, &ctx->clock);
     if ( sc != ALT_E_SUCCESS ) {
       ret = false;
@@ -146,6 +74,4 @@
     // Verify the UCR (UART Component Version)
     ucr = alt_read_word( ALT_UART_UCV_ADDR( location ) );
-
-    assert( ucr == ALT_UART_UCV_UART_COMPONENT_VER_RESET );
     if ( ucr != ALT_UART_UCV_UART_COMPONENT_VER_RESET ) {
       ret = false;
@@ -159,4 +85,6 @@
     // Read the MSR to work around case:119085.
     (void)alt_read_word( ALT_UART_MSR_ADDR( location ) );
+
+    ret = ns16550_probe( base );
   }
 
@@ -164,15 +92,66 @@
 }
 
+#ifdef CYCLONE_V_CONFIG_CONSOLE
+static bool altera_cyclone_v_uart_probe_0(rtems_termios_device_context *base)
+{
+  return altera_cyclone_v_uart_probe(base, ALT_RSTMGR_PERMODRST_UART0_SET_MSK);
+}
+
+static ns16550_context altera_cyclone_v_uart_context_0 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 0"),
+  .get_reg = altera_cyclone_v_uart_get_register,
+  .set_reg = altera_cyclone_v_uart_set_register,
+  .port = (uintptr_t) ALT_UART0_ADDR,
+  .irq = ALT_INT_INTERRUPT_UART0,
+  .initial_baud = CYCLONE_V_UART_BAUD
+};
+#endif
+
+#ifdef CYCLONE_V_CONFIG_CONSOLE
+static bool altera_cyclone_v_uart_probe_1(rtems_termios_device_context *base)
+{
+  return altera_cyclone_v_uart_probe(base, ALT_RSTMGR_PERMODRST_UART1_SET_MSK);
+}
+
+static ns16550_context altera_cyclone_v_uart_context_1 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 1"),
+  .get_reg = altera_cyclone_v_uart_get_register,
+  .set_reg = altera_cyclone_v_uart_set_register,
+  .port = (uintptr_t) ALT_UART1_ADDR,
+  .irq = ALT_INT_INTERRUPT_UART1,
+  .initial_baud = CYCLONE_V_UART_BAUD
+};
+#endif
+
+const console_device console_device_table[] = {
+  #ifdef CYCLONE_V_CONFIG_CONSOLE
+    {
+      .device_file = "/dev/ttyS0",
+      .probe = altera_cyclone_v_uart_probe_0,
+      .handler = DEVICE_FNS,
+      .context = &altera_cyclone_v_uart_context_0.base
+    },
+  #endif
+  #ifdef CYCLONE_V_CONFIG_UART_1
+    {
+      .device_file = "/dev/ttyS1",
+      .probe = altera_cyclone_v_uart_probe_1,
+      .handler = DEVICE_FNS,
+      .context = &altera_cyclone_v_uart_context_1.base
+    },
+  #endif
+};
+
+const size_t console_device_count = RTEMS_ARRAY_SIZE(console_device_table);
+
 static void output_char(char c)
 {
-  int minor = (int) Console_Port_Minor;
-  console_tbl *ct = Console_Port_Tbl != NULL ?
-    Console_Port_Tbl[minor] : &Console_Configuration_Ports[minor];
+  rtems_termios_device_context *ctx = console_device_table[0].context;
 
   if (c == '\n') {
-    ns16550_outch_polled( ct, '\r' );
+    ns16550_polled_putchar( ctx, '\r' );
   }
 
-  ns16550_outch_polled( ct, c );
+  ns16550_polled_putchar( ctx, c );
 }
 
Index: c/src/lib/libbsp/arm/lpc176x/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/lpc176x/Makefile.am	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc176x/Makefile.am	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -111,9 +111,6 @@
 
 # Console
-libbsp_a_SOURCES += ../../shared/console.c
-libbsp_a_SOURCES += ../../shared/console_control.c
-libbsp_a_SOURCES += ../../shared/console_read.c
-libbsp_a_SOURCES += ../../shared/console_select.c
-libbsp_a_SOURCES += ../../shared/console_write.c
+libbsp_a_SOURCES += ../../shared/console-termios-init.c
+libbsp_a_SOURCES += ../../shared/console-termios.c
 libbsp_a_SOURCES += console/console-config.c
 
Index: c/src/lib/libbsp/arm/lpc176x/console/console-config.c
===================================================================
--- c/src/lib/libbsp/arm/lpc176x/console/console-config.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc176x/console/console-config.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2008-2011 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2008-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -21,5 +21,4 @@
  */
 
-#include <libchip/serial.h>
 #include <libchip/ns16550.h>
 
@@ -27,4 +26,5 @@
 #include <bsp/io.h>
 #include <bsp/irq.h>
+#include <bsp/console-termios.h>
 
 /**
@@ -63,96 +63,90 @@
 }
 
-/**
- * @brief Represents the uart configuration ports.
- */
-console_tbl Console_Configuration_Ports[] = {
 #ifdef LPC176X_CONFIG_CONSOLE
-  {
-    .sDeviceName = "/dev/ttyS0",
-    .deviceType = SERIAL_NS16550_WITH_FDR,
-    .pDeviceFns = &ns16550_fns,
-    .deviceProbe = NULL,
-    .pDeviceFlow = NULL,
-    .ulMargin = 16,
-    .ulHysteresis = 8,
-    .pDeviceParams = (void *) LPC176X_UART_BAUD,
-    .ulCtrlPort1 = UART0_BASE_ADDR,
-    .ulCtrlPort2 = 0,
-    .ulDataPort = UART0_BASE_ADDR,
-    .getRegister = lpc176x_uart_get_register,
-    .setRegister = lpc176x_uart_set_register,
-    .getData = NULL,
-    .setData = NULL,
-    .ulClock = LPC176X_PCLK,
-    .ulIntVector = LPC176X_IRQ_UART_0
-  },
+static ns16550_context lpc176x_uart_context_0 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 0"),
+  .get_reg = lpc176x_uart_get_register,
+  .set_reg = lpc176x_uart_set_register,
+  .port = UART0_BASE_ADDR,
+  .irq = LPC176X_IRQ_UART_0,
+  .clock = LPC176X_PCLK,
+  .initial_baud = LPC176X_UART_BAUD,
+  .has_fractional_divider_register = true
+};
 #endif
+
 #ifdef LPC176X_CONFIG_UART_1
-  {
-    .sDeviceName = "/dev/ttyS1",
-    .deviceType = SERIAL_NS16550_WITH_FDR,
-    .pDeviceFns = &ns16550_fns,
-    .deviceProbe = lpc176x_uart_probe_1,
-    .pDeviceFlow = NULL,
-    .ulMargin = 16,
-    .ulHysteresis = 8,
-    .pDeviceParams = (void *) LPC176X_UART_BAUD,
-    .ulCtrlPort1 = UART1_BASE_ADDR,
-    .ulCtrlPort2 = 0,
-    .ulDataPort = UART1_BASE_ADDR,
-    .getRegister = lpc176x_uart_get_register,
-    .setRegister = lpc176x_uart_set_register,
-    .getData = NULL,
-    .setData = NULL,
-    .ulClock = LPC176X_PCLK,
-    .ulIntVector = LPC176X_IRQ_UART_1
-  },
+static ns16550_context lpc176x_uart_context_1 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 1"),
+  .get_reg = lpc176x_uart_get_register,
+  .set_reg = lpc176x_uart_set_register,
+  .port = UART1_BASE_ADDR,
+  .irq = LPC176X_IRQ_UART_1,
+  .clock = LPC176X_PCLK,
+  .initial_baud = LPC176X_UART_BAUD,
+  .has_fractional_divider_register = true
+};
 #endif
+
 #ifdef LPC176X_CONFIG_UART_2
-  {
-    .sDeviceName = "/dev/ttyS2",
-    .deviceType = SERIAL_NS16550_WITH_FDR,
-    .pDeviceFns = &ns16550_fns,
-    .deviceProbe = lpc176x_uart_probe_2,
-    .pDeviceFlow = NULL,
-    .ulMargin = 16,
-    .ulHysteresis = 8,
-    .pDeviceParams = (void *) LPC176X_UART_BAUD,
-    .ulCtrlPort1 = UART2_BASE_ADDR,
-    .ulCtrlPort2 = 0,
-    .ulDataPort = UART2_BASE_ADDR,
-    .getRegister = lpc176x_uart_get_register,
-    .setRegister = lpc176x_uart_set_register,
-    .getData = NULL,
-    .setData = NULL,
-    .ulClock = LPC176X_PCLK,
-    .ulIntVector = LPC176X_IRQ_UART_2
-  },
+static ns16550_context lpc176x_uart_context_2 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 2"),
+  .get_reg = lpc176x_uart_get_register,
+  .set_reg = lpc176x_uart_set_register,
+  .port = UART2_BASE_ADDR,
+  .irq = LPC176X_IRQ_UART_2,
+  .clock = LPC176X_PCLK,
+  .initial_baud = LPC176X_UART_BAUD,
+  .has_fractional_divider_register = true
+};
 #endif
+
 #ifdef LPC176X_CONFIG_UART_3
-  {
-    .sDeviceName = "/dev/ttyS3",
-    .deviceType = SERIAL_NS16550_WITH_FDR,
-    .pDeviceFns = &ns16550_fns,
-    .deviceProbe = lpc176x_uart_probe_3,
-    .pDeviceFlow = NULL,
-    .ulMargin = 16,
-    .ulHysteresis = 8,
-    .pDeviceParams = (void *) LPC176X_UART_BAUD,
-    .ulCtrlPort1 = UART3_BASE_ADDR,
-    .ulCtrlPort2 = 0,
-    .ulDataPort = UART3_BASE_ADDR,
-    .getRegister = lpc176x_uart_get_register,
-    .setRegister = lpc176x_uart_set_register,
-    .getData = NULL,
-    .setData = NULL,
-    .ulClock = LPC176X_PCLK,
-    .ulIntVector = LPC176X_IRQ_UART_3
-  },
+static ns16550_context lpc176x_uart_context_3 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 3"),
+  .get_reg = lpc176x_uart_get_register,
+  .set_reg = lpc176x_uart_set_register,
+  .port = UART3_BASE_ADDR,
+  .irq = LPC176X_IRQ_UART_3,
+  .clock = LPC176X_PCLK,
+  .initial_baud = LPC176X_UART_BAUD,
+  .has_fractional_divider_register = true
+};
 #endif
+
+const console_device console_device_table[] = {
+  #ifdef LPC176X_CONFIG_CONSOLE
+    {
+      .device_file = "/dev/ttyS0",
+      .probe = console_device_probe_default,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc176x_uart_context_0.base
+    },
+  #endif
+  #ifdef LPC176X_CONFIG_UART_1
+    {
+      .device_file = "/dev/ttyS1",
+      .probe = ns16550_probe,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc176x_uart_context_1.base
+    },
+  #endif
+  #ifdef LPC176X_CONFIG_UART_2
+    {
+      .device_file = "/dev/ttyS2",
+      .probe = ns16550_probe,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc176x_uart_context_2.base
+    },
+  #endif
+  #ifdef LPC176X_CONFIG_UART_3
+    {
+      .device_file = "/dev/ttyS3",
+      .probe = ns16550_probe,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc176x_uart_context_3.base
+    },
+  #endif
 };
 
-#define LPC176X_UART_COUNT ( sizeof( Console_Configuration_Ports ) \
-                             / sizeof( Console_Configuration_Ports[ 0 ] ) )
-
-unsigned long Console_Configuration_Count = LPC176X_UART_COUNT;
+const size_t console_device_count = RTEMS_ARRAY_SIZE(console_device_table);
Index: c/src/lib/libbsp/arm/lpc24xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/lpc24xx/Makefile.am	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc24xx/Makefile.am	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -122,9 +122,6 @@
 
 # Console
-libbsp_a_SOURCES += ../../shared/console.c
-libbsp_a_SOURCES += ../../shared/console_control.c
-libbsp_a_SOURCES += ../../shared/console_read.c
-libbsp_a_SOURCES += ../../shared/console_select.c
-libbsp_a_SOURCES += ../../shared/console_write.c
+libbsp_a_SOURCES += ../../shared/console-termios-init.c
+libbsp_a_SOURCES += ../../shared/console-termios.c
 libbsp_a_SOURCES += console/console-config.c
 libbsp_a_SOURCES += console/uart-probe-1.c
Index: c/src/lib/libbsp/arm/lpc24xx/console/console-config.c
===================================================================
--- c/src/lib/libbsp/arm/lpc24xx/console/console-config.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc24xx/console/console-config.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2008-2011 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2008-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -21,5 +21,6 @@
  */
 
-#include <libchip/serial.h>
+#include <rtems/console.h>
+
 #include <libchip/ns16550.h>
 
@@ -28,4 +29,5 @@
 #include <bsp/irq.h>
 #include <bsp/io.h>
+#include <bsp/console-termios.h>
 
 static uint8_t lpc24xx_uart_get_register(uintptr_t addr, uint8_t i)
@@ -43,93 +45,90 @@
 }
 
-console_tbl Console_Configuration_Ports [] = {
+#ifdef LPC24XX_CONFIG_CONSOLE
+static ns16550_context lpc24xx_uart_context_0 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 0"),
+  .get_reg = lpc24xx_uart_get_register,
+  .set_reg = lpc24xx_uart_set_register,
+  .port = UART0_BASE_ADDR,
+  .irq = LPC24XX_IRQ_UART_0,
+  .clock = LPC24XX_PCLK,
+  .initial_baud = LPC24XX_UART_BAUD,
+  .has_fractional_divider_register = true
+};
+#endif
+
+#ifdef LPC24XX_CONFIG_UART_1
+static ns16550_context lpc24xx_uart_context_1 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 1"),
+  .get_reg = lpc24xx_uart_get_register,
+  .set_reg = lpc24xx_uart_set_register,
+  .port = UART1_BASE_ADDR,
+  .irq = LPC24XX_IRQ_UART_1,
+  .clock = LPC24XX_PCLK,
+  .initial_baud = LPC24XX_UART_BAUD,
+  .has_fractional_divider_register = true
+};
+#endif
+
+#ifdef LPC24XX_CONFIG_UART_2
+static ns16550_context lpc24xx_uart_context_2 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 2"),
+  .get_reg = lpc24xx_uart_get_register,
+  .set_reg = lpc24xx_uart_set_register,
+  .port = UART2_BASE_ADDR,
+  .irq = LPC24XX_IRQ_UART_2,
+  .clock = LPC24XX_PCLK,
+  .initial_baud = LPC24XX_UART_BAUD,
+  .has_fractional_divider_register = true
+};
+#endif
+
+#ifdef LPC24XX_CONFIG_UART_3
+static ns16550_context lpc24xx_uart_context_3 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 3"),
+  .get_reg = lpc24xx_uart_get_register,
+  .set_reg = lpc24xx_uart_set_register,
+  .port = UART3_BASE_ADDR,
+  .irq = LPC24XX_IRQ_UART_3,
+  .clock = LPC24XX_PCLK,
+  .initial_baud = LPC24XX_UART_BAUD,
+  .has_fractional_divider_register = true
+};
+#endif
+
+const console_device console_device_table[] = {
   #ifdef LPC24XX_CONFIG_CONSOLE
     {
-      .sDeviceName = "/dev/ttyS0",
-      .deviceType = SERIAL_NS16550_WITH_FDR,
-      .pDeviceFns = &ns16550_fns,
-      .deviceProbe = NULL,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC24XX_UART_BAUD,
-      .ulCtrlPort1 = UART0_BASE_ADDR,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = UART0_BASE_ADDR,
-      .getRegister = lpc24xx_uart_get_register,
-      .setRegister = lpc24xx_uart_set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = LPC24XX_PCLK,
-      .ulIntVector = LPC24XX_IRQ_UART_0
+      .device_file = "/dev/ttyS0",
+      .probe = console_device_probe_default,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc24xx_uart_context_0.base
     },
   #endif
   #ifdef LPC24XX_CONFIG_UART_1
     {
-      .sDeviceName = "/dev/ttyS1",
-      .deviceType = SERIAL_NS16550_WITH_FDR,
-      .pDeviceFns = &ns16550_fns,
-      .deviceProbe = lpc24xx_uart_probe_1,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC24XX_UART_BAUD,
-      .ulCtrlPort1 = UART1_BASE_ADDR,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = UART1_BASE_ADDR,
-      .getRegister = lpc24xx_uart_get_register,
-      .setRegister = lpc24xx_uart_set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = LPC24XX_PCLK,
-      .ulIntVector = LPC24XX_IRQ_UART_1
+      .device_file = "/dev/ttyS1",
+      .probe = lpc24xx_uart_probe_1,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc24xx_uart_context_1.base
     },
   #endif
   #ifdef LPC24XX_CONFIG_UART_2
     {
-      .sDeviceName = "/dev/ttyS2",
-      .deviceType = SERIAL_NS16550_WITH_FDR,
-      .pDeviceFns = &ns16550_fns,
-      .deviceProbe = lpc24xx_uart_probe_2,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC24XX_UART_BAUD,
-      .ulCtrlPort1 = UART2_BASE_ADDR,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = UART2_BASE_ADDR,
-      .getRegister = lpc24xx_uart_get_register,
-      .setRegister = lpc24xx_uart_set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = LPC24XX_PCLK,
-      .ulIntVector = LPC24XX_IRQ_UART_2
+      .device_file = "/dev/ttyS2",
+      .probe = lpc24xx_uart_probe_2,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc24xx_uart_context_2.base
     },
   #endif
   #ifdef LPC24XX_CONFIG_UART_3
     {
-      .sDeviceName = "/dev/ttyS3",
-      .deviceType = SERIAL_NS16550_WITH_FDR,
-      .pDeviceFns = &ns16550_fns,
-      .deviceProbe = lpc24xx_uart_probe_3,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC24XX_UART_BAUD,
-      .ulCtrlPort1 = UART3_BASE_ADDR,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = UART3_BASE_ADDR,
-      .getRegister = lpc24xx_uart_get_register,
-      .setRegister = lpc24xx_uart_set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = LPC24XX_PCLK,
-      .ulIntVector = LPC24XX_IRQ_UART_3
+      .device_file = "/dev/ttyS3",
+      .probe = lpc24xx_uart_probe_3,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc24xx_uart_context_3.base
     },
   #endif
 };
 
-#define LPC24XX_UART_COUNT \
-  (sizeof(Console_Configuration_Ports) \
-    / sizeof(Console_Configuration_Ports [0]))
-unsigned long Console_Configuration_Count = LPC24XX_UART_COUNT;
+const size_t console_device_count = RTEMS_ARRAY_SIZE(console_device_table);
Index: c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-1.c
===================================================================
--- c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-1.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-1.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2011-2013 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2011-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -21,8 +21,10 @@
  */
 
+#include <libchip/ns16550.h>
+
 #include <bsp.h>
 #include <bsp/io.h>
 
-bool lpc24xx_uart_probe_1(int minor)
+bool lpc24xx_uart_probe_1(rtems_termios_device_context *context)
 {
   static const lpc24xx_pin_range pins [] = {
@@ -35,4 +37,4 @@
   lpc24xx_pin_config(&pins [0], LPC24XX_PIN_SET_FUNCTION);
 
-  return true;
+  return ns16550_probe(context);
 }
Index: c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-2.c
===================================================================
--- c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-2.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-2.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2011-2013 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2011-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -21,8 +21,10 @@
  */
 
+#include <libchip/ns16550.h>
+
 #include <bsp.h>
 #include <bsp/io.h>
 
-bool lpc24xx_uart_probe_2(int minor)
+bool lpc24xx_uart_probe_2(rtems_termios_device_context *context)
 {
   static const lpc24xx_pin_range pins [] = {
@@ -35,4 +37,4 @@
   lpc24xx_pin_config(&pins [0], LPC24XX_PIN_SET_FUNCTION);
 
-  return true;
+  return ns16550_probe(context);
 }
Index: c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-3.c
===================================================================
--- c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-3.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc24xx/console/uart-probe-3.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2011-2013 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2011-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -21,8 +21,10 @@
  */
 
+#include <libchip/ns16550.h>
+
 #include <bsp.h>
 #include <bsp/io.h>
 
-bool lpc24xx_uart_probe_3(int minor)
+bool lpc24xx_uart_probe_3(rtems_termios_device_context *context)
 {
   static const lpc24xx_pin_range pins [] = {
@@ -35,4 +37,4 @@
   lpc24xx_pin_config(&pins [0], LPC24XX_PIN_SET_FUNCTION);
 
-  return true;
+  return ns16550_probe(context);
 }
Index: c/src/lib/libbsp/arm/lpc24xx/include/bsp.h
===================================================================
--- c/src/lib/libbsp/arm/lpc24xx/include/bsp.h	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc24xx/include/bsp.h	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2008-2013 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2008-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -53,4 +53,6 @@
 
 struct rtems_bsdnet_ifconfig;
+
+struct rtems_termios_device_context;
 
 /**
@@ -112,9 +114,9 @@
 void bsp_restart(void *addr);
 
-bool lpc24xx_uart_probe_1(int minor);
+bool lpc24xx_uart_probe_1(struct rtems_termios_device_context *context);
 
-bool lpc24xx_uart_probe_2(int minor);
+bool lpc24xx_uart_probe_2(struct rtems_termios_device_context *context);
 
-bool lpc24xx_uart_probe_3(int minor);
+bool lpc24xx_uart_probe_3(struct rtems_termios_device_context *context);
 
 /** @} */
Index: c/src/lib/libbsp/arm/lpc32xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/lpc32xx/Makefile.am	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc32xx/Makefile.am	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -49,4 +49,5 @@
 include_bsp_HEADERS += include/nand-mlc.h
 include_bsp_HEADERS += include/boot.h
+include_bsp_HEADERS += include/hsu.h
 include_bsp_HEADERS += include/i2c.h
 include_bsp_HEADERS += include/emc.h
@@ -112,11 +113,8 @@
 
 # Console
-libbsp_a_SOURCES += ../../shared/console.c \
-        ../../shared/console_select.c \
-	console/console-config.c \
-	console/hsu.c \
-        ../../shared/console_read.c \
-        ../../shared/console_write.c \
-        ../../shared/console_control.c
+libbsp_a_SOURCES += ../../shared/console-termios-init.c
+libbsp_a_SOURCES += ../../shared/console-termios.c
+libbsp_a_SOURCES += console/console-config.c
+libbsp_a_SOURCES += console/hsu.c
 
 # Clock
